Index: trunk/NEMO/OPA_SRC/iom.F90
===================================================================
--- trunk/NEMO/OPA_SRC/iom.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/iom.F90	(revision 508)
@@ -556,186 +601,317 @@
               CALL fliogetv( knumfl, cdvar, pv_r3d(:,:,:), start=istart(1:inbdim), count=icnt(1:inbdim) )
               !--- Apply scale_factor and offset
-              IF (zscf /= 1.)   pv_r3d(:,:,:) = pv_r3d(:,:,:) * zscf
-              IF (zofs /= 0.)   pv_r3d(:,:,:) = pv_r3d(:,:,:) + zofs
+!CDIR COLLAPSE
+              IF( zscf /= 1.)   pv_r3d(:,:,:) = pv_r3d(:,:,:) * zscf
+!CDIR COLLAPSE
+              IF( zofs /= 0.)   pv_r3d(:,:,:) = pv_r3d(:,:,:) + zofs
            ENDIF
         ENDIF
         !
-        IF( istop == nstop .AND. lwp )  &
-             &  WRITE(numout,*) ' read '//trim(cdvar)//' in '//trim(iom_file(knumfl)%name)//' ok'
+        IF( istop == nstop .AND. lwp )   &
+           WRITE(numout,*) '           read '//trim(cdvar)//' in '//trim(iom_file(knumfl)%name)//' ok'
      ENDIF
      !
-   END SUBROUTINE iom_u_getv
+   END SUBROUTINE iom_get_123d
 
    
    SUBROUTINE iom_gettime( knumfl, cdvar, ptime )
-     !!--------------------------------------------------------------------
-     !!                   ***  SUBROUTINE  iom_close  ***
-     !!
-     !! ** Purpose : read the time axis cdvar in the file 
-     !!
-     !! ** Method :
-     !!
-     !!--------------------------------------------------------------------
-     INTEGER               , INTENT(in)  ::   knumfl   ! Identifier of the file to be closed
-     CHARACTER(len=*)      , INTENT(in)  ::   cdvar    ! time axis name
-     REAL(wp), DIMENSION(:), INTENT(out) ::   ptime    ! the time axis
-
-     INTEGER           :: idvar    ! id of the variable
-     CHARACTER(LEN=100) :: clinfo                    ! info character
-     !---------------------------------------------------------------------
-     clinfo = 'iom_gettime, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
-     idvar = iom_varid( knumfl, cdvar )
-     !
-     ptime(:) = 0. ! default definition
-     IF ( idvar > 0 ) THEN
-        IF ( iom_file(knumfl)%ndims(idvar) == 1 ) THEN
-           IF ( iom_file(knumfl)%luld(idvar) ) THEN
-              IF ( iom_file(knumfl)%dimsz(1,idvar) == size(ptime) ) THEN
-                 CALL fliogetv( knumfl, cdvar, ptime(:), start=(/ 1 /), &
-                      &                                   count=(/ iom_file(knumfl)%dimsz(1,idvar) /) )
-              ELSE
-                 WRITE(ctmp1,*) 'error with the size of ptime ',size(ptime),iom_file(knumfl)%dimsz(1,idvar)
-                 CALL ctl_stop( trim(clinfo), trim(ctmp1) )
-              ENDIF
-           ELSE
-              CALL ctl_stop( trim(clinfo), 'variable dimension is not unlimited... use iom_get' )
-           ENDIF
-        ELSE
-           CALL ctl_stop( trim(clinfo), 'the variable has more than 1 dimension' )
-        ENDIF
-     ELSE
-        CALL ctl_stop( trim(clinfo), 'variable not found in '//iom_file(knumfl)%name )
-     ENDIF
-
+      !!--------------------------------------------------------------------
+      !!                   ***  SUBROUTINE iom_gettime  ***
+      !!
+      !! ** Purpose : read the time axis cdvar in the file 
+      !!--------------------------------------------------------------------
+      INTEGER               , INTENT(in   ) ::   knumfl   ! file Identifier
+      CHARACTER(len=*)      , INTENT(in   ) ::   cdvar    ! time axis name
+      REAL(wp), DIMENSION(:), INTENT(  out) ::   ptime    ! the time axis
+      !
+      INTEGER            ::   idvar    ! id of the variable
+      CHARACTER(LEN=100) ::   clinfo   ! info character
+      !---------------------------------------------------------------------
+      !
+      clinfo = 'iom_gettime, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
+      idvar = iom_varid( knumfl, cdvar )
+      !
+      ptime(:) = 0. ! default definition
+      IF( idvar > 0 ) THEN
+         IF( iom_file(knumfl)%ndims(idvar) == 1 ) THEN
+            IF( iom_file(knumfl)%luld(idvar) ) THEN
+               IF( iom_file(knumfl)%dimsz(1,idvar) == size(ptime) ) THEN
+                  CALL fliogetv( knumfl, cdvar, ptime(:), start=(/ 1 /),   &
+                     &                                    count=(/ iom_file(knumfl)%dimsz(1,idvar) /) )
+               ELSE
+                  WRITE(ctmp1,*) 'error with the size of ptime ',size(ptime),iom_file(knumfl)%dimsz(1,idvar)
+                  CALL ctl_stop( trim(clinfo), trim(ctmp1) )
+               ENDIF
+            ELSE
+               CALL ctl_stop( trim(clinfo), 'variable dimension is not unlimited... use iom_get' )
+            ENDIF
+         ELSE
+            CALL ctl_stop( trim(clinfo), 'the variable has more than 1 dimension' )
+         ENDIF
+      ELSE
+         CALL ctl_stop( trim(clinfo), 'variable not found in '//iom_file(knumfl)%name )
+      ENDIF
+      !
    END SUBROUTINE iom_gettime
     
     
-    
    FUNCTION iom_varid ( knumfl, cdvar, kdimsz )  
-     !!-----------------------------------------------------------------------
-     !!                  ***  FUNCTION  iom_varid  ***
-     !!
-     !! ** Purpose : get the id of a variable in a file (return 0 if not found)
-     !!
-     !! ** Method : ???
-     !!
-     !!-----------------------------------------------------------------------
-     INTEGER              , INTENT(in)            ::   knumfl   ! file Identifier
-     CHARACTER(len=*)     , INTENT(in)            ::   cdvar    ! name of the variable
-     INTEGER, DIMENSION(:), INTENT(out), OPTIONAL ::   kdimsz   ! size of the dimensions
-     !
-     INTEGER                        :: iom_varid, idvar, i_nvd, ji
-     INTEGER, DIMENSION(jpmax_dims) :: idimid
-     LOGICAL                        :: ll_fnd
-     CHARACTER(LEN=100)             :: clinfo                   ! info character
-     !!-----------------------------------------------------------------------
-     clinfo = 'iom_varid, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
-     iom_varid = 0                         ! default definition
-     IF ( PRESENT(kdimsz) ) kdimsz(:) = 0  ! default definition
-     !
-     IF ( knumfl > 0 ) THEN
-        IF( iom_file(knumfl)%iopen == 0 ) THEN 
-           CALL ctl_stop( trim(clinfo), 'the file is not open' )
-        ELSE
-           !
-           ll_fnd  = .FALSE.
-           idvar = 0
-           !
-           DO WHILE ( .NOT.ll_fnd .AND. idvar < iom_file(knumfl)%nvars )
-              idvar = idvar + 1
-              ll_fnd  = ( TRIM(cdvar) == TRIM(iom_file(knumfl)%cn_var(idvar)) )
-           END DO
-           !
-           IF( .NOT.ll_fnd ) THEN
-              idvar = idvar + 1
-              IF( idvar <= jpmax_vars ) THEN
-                 CALL flioinqv( knumfl, cdvar, ll_fnd, nb_dims = i_nvd )
-                 IF( ll_fnd ) THEN
-                    IF( i_nvd <= jpmax_dims ) THEN
-                       iom_file(knumfl)%nvars           = idvar
-                       iom_file(knumfl)%cn_var(idvar) = trim(cdvar)
-                       iom_file(knumfl)%ndims(idvar)  = i_nvd
-                       CALL flioinqv( knumfl, cdvar, ll_fnd, &
-                            &         len_dims = iom_file(knumfl)%dimsz(1:i_nvd,idvar), &
-                            &         id_dims  = idimid(1:i_nvd) )
-                       DO ji = 1, i_nvd
-                          IF ( idimid(ji) == iom_file(knumfl)%iduld ) iom_file(knumfl)%luld(idvar) = .TRUE.
-                       END DO
-                       !----------
-                       !---------- Deal with scale_factor and offset
-                       CALL flioinqa( knumfl, cdvar, 'scale_factor', ll_fnd )
-                       IF (ll_fnd) THEN
-                          CALL fliogeta( knumfl, cdvar, 'scale_factor', iom_file(knumfl)%scf(idvar) )
-                       ELSE
-                          iom_file(knumfl)%scf(idvar) = 1.
-                       END IF
-                       CALL flioinqa( knumfl, cdvar, 'offset', ll_fnd )
-                       IF( ll_fnd ) THEN
-                          CALL fliogeta( knumfl, cdvar, 'offset', iom_file(knumfl)%ofs(idvar) )
-                       ELSE
-                          iom_file(knumfl)%ofs(idvar) = 0.
-                       END IF
-                       !
-                       iom_varid = idvar
-                       IF ( PRESENT(kdimsz) ) THEN 
-                          IF ( i_nvd == size(kdimsz) ) THEN
-                             kdimsz(:) = iom_file(knumfl)%dimsz(1:i_nvd,idvar)
-                          ELSE
-                             WRITE(ctmp1,*) i_nvd, size(kdimsz)
-                             CALL ctl_stop( trim(clinfo), 'error in kdimsz size'//trim(ctmp1) )
-                          ENDIF
-                       ENDIF
-                    ELSE
-                       CALL ctl_stop( trim(clinfo), 'Too many dimensions in the file '//iom_file(knumfl)%name,   &
-                            &           'increase the parameter jpmax_vars')
-                    ENDIF
-                 ELSE  
-                    CALL ctl_warn( trim(clinfo), 'Variable '//trim(cdvar)// &
-                         & ' is not found in the file '//trim(iom_file(knumfl)%name) )
-                 ENDIF
-              ELSE
-                 CALL ctl_stop( trim(clinfo), 'Too many variables in the file '//iom_file(knumfl)%name,   &
-                      &           'increase the parameter jpmax_vars')
-              ENDIF
-           ELSE
-              iom_varid = idvar
-              IF ( PRESENT(kdimsz) ) THEN 
-                 i_nvd = iom_file(knumfl)%ndims(idvar)
-                 IF ( i_nvd == size(kdimsz) ) THEN
-                    kdimsz(:) = iom_file(knumfl)%dimsz(1:i_nvd,idvar)
-                 ELSE
-                    WRITE(ctmp1,*) i_nvd, size(kdimsz)
-                    CALL ctl_stop( trim(clinfo), 'error in kdimsz size'//trim(ctmp1) )
-                 ENDIF
-              ENDIF
-           ENDIF
-        ENDIF
-     ENDIF
-
+      !!-----------------------------------------------------------------------
+      !!                  ***  FUNCTION  iom_varid  ***
+      !!
+      !! ** Purpose : get the id of a variable in a file (return 0 if not found)
+      !!-----------------------------------------------------------------------
+      INTEGER              , INTENT(in   )           ::   knumfl   ! file Identifier
+      CHARACTER(len=*)     , INTENT(in   )           ::   cdvar    ! name of the variable
+      INTEGER, DIMENSION(:), INTENT(  out), OPTIONAL ::   kdimsz   ! size of the dimensions
+      !
+      INTEGER                        ::   ji                       ! dummy loop index
+      INTEGER                        ::   iom_varid, idvar, i_nvd
+      INTEGER, DIMENSION(jpmax_dims) ::   idimid
+      LOGICAL                        ::   ll_fnd
+      CHARACTER(LEN=100)             ::   clinfo                   ! info character
+      !!-----------------------------------------------------------------------
+      clinfo = 'iom_varid, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
+      iom_varid = 0                         ! default definition
+      IF( PRESENT(kdimsz) ) kdimsz(:) = 0   ! default definition
+      !
+      IF( knumfl > 0 ) THEN
+         IF( iom_file(knumfl)%iopen == 0 ) THEN 
+            CALL ctl_stop( trim(clinfo), 'the file is not open' )
+         ELSE
+            ll_fnd  = .FALSE.
+            idvar = 0
+            !
+            DO WHILE ( .NOT.ll_fnd .AND. idvar < iom_file(knumfl)%nvars )
+               idvar = idvar + 1
+               ll_fnd  = ( TRIM(cdvar) == TRIM(iom_file(knumfl)%cn_var(idvar)) )
+            END DO
+            !
+            IF( .NOT.ll_fnd ) THEN
+               idvar = idvar + 1
+               IF( idvar <= jpmax_vars ) THEN
+                  CALL flioinqv( knumfl, cdvar, ll_fnd, nb_dims = i_nvd )
+                  IF( ll_fnd ) THEN
+                     IF( i_nvd <= jpmax_dims ) THEN
+                        iom_file(knumfl)%nvars           = idvar
+                        iom_file(knumfl)%cn_var(idvar) = trim(cdvar)
+                        iom_file(knumfl)%ndims(idvar)  = i_nvd
+                        CALL flioinqv( knumfl, cdvar, ll_fnd,   &
+                           &           len_dims = iom_file(knumfl)%dimsz(1:i_nvd,idvar), &
+                           &           id_dims  = idimid(1:i_nvd) )
+                        DO ji = 1, i_nvd
+                           IF( idimid(ji) == iom_file(knumfl)%iduld ) iom_file(knumfl)%luld(idvar) = .TRUE.
+                        END DO
+                        !----------
+                        !---------- Deal with scale_factor and offset
+                        CALL flioinqa( knumfl, cdvar, 'scale_factor', ll_fnd )
+                        IF( ll_fnd) THEN
+                           CALL fliogeta( knumfl, cdvar, 'scale_factor', iom_file(knumfl)%scf(idvar) )
+                        ELSE
+                           iom_file(knumfl)%scf(idvar) = 1.
+                        END IF
+                        CALL flioinqa( knumfl, cdvar, 'offset', ll_fnd )
+                        IF( ll_fnd ) THEN
+                           CALL fliogeta( knumfl, cdvar, 'offset', iom_file(knumfl)%ofs(idvar) )
+                        ELSE
+                           iom_file(knumfl)%ofs(idvar) = 0.
+                        END IF
+                        !
+                        iom_varid = idvar
+                        IF( PRESENT(kdimsz) ) THEN 
+                           IF( i_nvd == size(kdimsz) ) THEN
+                              kdimsz(:) = iom_file(knumfl)%dimsz(1:i_nvd,idvar)
+                           ELSE
+                              WRITE(ctmp1,*) i_nvd, size(kdimsz)
+                              CALL ctl_stop( trim(clinfo), 'error in kdimsz size'//trim(ctmp1) )
+                           ENDIF
+                        ENDIF
+                     ELSE
+                        CALL ctl_stop( trim(clinfo), 'Too many dimensions in the file '//iom_file(knumfl)%name,   &
+                           &                        'increase the parameter jpmax_vars')
+                     ENDIF
+!!$                  ELSE  
+!!$                     CALL ctl_warn( trim(clinfo), 'Variable '//trim(cdvar)// &
+!!$                        &                         ' is not found in the file '//trim(iom_file(knumfl)%name) )
+                  ENDIF
+               ELSE
+                  CALL ctl_stop( trim(clinfo), 'Too many variables in the file '//iom_file(knumfl)%name,   &
+                     &                         'increase the parameter jpmax_vars')
+               ENDIF
+            ELSE
+               iom_varid = idvar
+               IF( PRESENT(kdimsz) ) THEN 
+                  i_nvd = iom_file(knumfl)%ndims(idvar)
+                  IF( i_nvd == size(kdimsz) ) THEN
+                     kdimsz(:) = iom_file(knumfl)%dimsz(1:i_nvd,idvar)
+                  ELSE
+                     WRITE(ctmp1,*) i_nvd, size(kdimsz)
+                     CALL ctl_stop( trim(clinfo), 'error in kdimsz size'//trim(ctmp1) )
+                  ENDIF
+               ENDIF
+            ENDIF
+         ENDIF
+      ENDIF
+      !
    END FUNCTION iom_varid
 
-  
-   FUNCTION iom_get_gblatt( knumfl, kinfonum )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  iom_get_gblatt  ***
+   !!----------------------------------------------------------------------
+   !!                   INTERFACE iom_rstput
+   !!----------------------------------------------------------------------
+   SUBROUTINE iom_rstput_0d( kt, kwrite, knumfl, cdvar, pvar )
+      INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
+      INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
+      INTEGER         , INTENT(in)                         ::   knumfl   ! Identifier of the file 
+      CHARACTER(len=*), INTENT(in)                         ::   cdvar    ! time axis name
+      REAL(wp)        , INTENT(in)                         ::   pvar     ! read field
+      IF( knumfl > 0 )   CALL iom_rstput_0123d( kt, kwrite, knumfl, cdvar, pv_r0d = pvar )
+   END SUBROUTINE iom_rstput_0d
+
+   SUBROUTINE iom_rstput_1d( kt, kwrite, knumfl, cdvar, pvar )
+      INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
+      INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
+      INTEGER         , INTENT(in)                         ::   knumfl   ! Identifier of the file 
+      CHARACTER(len=*), INTENT(in)                         ::   cdvar    ! time axis name
+      REAL(wp)        , INTENT(in), DIMENSION(        jpk) ::   pvar     ! read field
+      IF( knumfl > 0 )    CALL iom_rstput_0123d( kt, kwrite, knumfl, cdvar, pv_r1d = pvar )
+   END SUBROUTINE iom_rstput_1d
+
+   SUBROUTINE iom_rstput_2d( kt, kwrite, knumfl, cdvar, pvar )
+      INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
+      INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
+      INTEGER         , INTENT(in)                         ::   knumfl   ! Identifier of the file 
+      CHARACTER(len=*), INTENT(in)                         ::   cdvar    ! time axis name
+      REAL(wp)        , INTENT(in), DIMENSION(jpi,jpj    ) ::   pvar     ! read field
+      IF( knumfl > 0 )   CALL iom_rstput_0123d( kt, kwrite, knumfl, cdvar, pv_r2d = pvar )
+   END SUBROUTINE iom_rstput_2d
+
+   SUBROUTINE iom_rstput_3d( kt, kwrite, knumfl, cdvar, pvar )
+      INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
+      INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
+      INTEGER         , INTENT(in)                         ::   knumfl   ! Identifier of the file 
+      CHARACTER(len=*), INTENT(in)                         ::   cdvar    ! time axis name
+      REAL(wp)        , INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvar     ! read field
+      IF( knumfl > 0 )   CALL iom_rstput_0123d( kt, kwrite, knumfl, cdvar, pv_r3d = pvar )
+   END SUBROUTINE iom_rstput_3d
+   !!----------------------------------------------------------------------
+
+   SUBROUTINE iom_rstput_0123d( kt, kwrite, knumfl, cdvar ,   &
+      &                             pv_r0d, pv_r1d, pv_r2d, pv_r3d )
+      !!--------------------------------------------------------------------
+      !!                   ***  SUBROUTINE  iom_rstput  ***
       !!
-      !! ** Purpose : ???
-      !!
-      !! ** Method : ???
-      !!
-      !!-----------------------------------------------------------------------
-      INTEGER,INTENT(in) :: knumfl
-      INTEGER,          intent(in) :: kinfonum
-      !
-      CHARACTER(LEN=10) :: clinfo
-      REAL(wp) :: iom_get_gblatt
-      !!-----------------------------------------------------------------------
-
-      WRITE(clinfo,*) kinfonum
-      clinfo = 'info'//trim(adjustl(clinfo))
-      CALL fliogeta (knumfl, "?", clinfo, iom_get_gblatt)
-
-   END FUNCTION iom_get_gblatt
-
+      !! ** Purpose : read the time axis cdvar in the file 
+      !!--------------------------------------------------------------------
+      INTEGER                   , INTENT(in)           ::   kt       ! ocean time-step
+      INTEGER                   , INTENT(in)           ::   kwrite   ! writing time-step
+      INTEGER                   , INTENT(in)           ::   knumfl   ! Identifier of the file 
+      CHARACTER(len=*)          , INTENT(in)           ::   cdvar    ! time axis name
+      REAL(wp)                  , INTENT(in), OPTIONAL ::   pv_r0d   ! read field
+      REAL(wp), DIMENSION(:)    , INTENT(in), OPTIONAL ::   pv_r1d   ! read field
+      REAL(wp), DIMENSION(:,:)  , INTENT(in), OPTIONAL ::   pv_r2d   ! read field
+      REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL ::   pv_r3d   ! read field
+      !
+      INTEGER               :: idims, idvar        
+      INTEGER               :: ix1, ix2, iy1, iy2       
+      INTEGER, DIMENSION(4) :: idimsz, idimid     
+      CHARACTER(LEN=100)    :: clinfo        ! info character
+      !---------------------------------------------------------------------
+      !
+      clinfo = '          iom_rstput_0123d, file: '//TRIM(iom_file(knumfl)%name)//', var: '//TRIM(cdvar)
+
+      ! define dimension variables if it is not already done
+      ! ==========================
+      IF( iom_file(knumfl)%nvars == 0 ) THEN
+         ! define the dimension variables if it is not already done
+         CALL fliodefv( knumfl,'nav_lon', (/1,2/), v_t=flio_r4   , axis='X',   &
+            &                  long_name="Longitude", units="degrees_east" )
+         CALL fliodefv( knumfl,'nav_lat', (/1,2/), v_t=flio_r4   , axis='Y',   &
+            &                  long_name="Latitude", units="degrees_north" )
+         CALL fliodefv( knumfl,'nav_lev', (/3/)  , v_t=flio_i4   , axis='Z',   &
+            &                  long_name="Model levels",units="model_levels")
+         CALL fliodefv( knumfl,'time_counter', (/4/), v_t=flio_r4, axis='T',   &
+            &                  long_name="Time axis", units='seconds since 0001-01-01 00:00:00' )
+         ! update informations structure related the dimension variable we just added...
+         iom_file(knumfl)%nvars       = 4
+         iom_file(knumfl)%luld(1:4)   = (/ .FALSE., .FALSE., .FALSE., .TRUE. /)
+         iom_file(knumfl)%cn_var(1:3) = (/ 'nav_lon', 'nav_lat', 'nav_lev' /)
+         iom_file(knumfl)%cn_var(4)   = 'time_counter'
+         iom_file(knumfl)%ndims(1:4)  = (/ 2, 2, 1, 1 /)  
+         IF(lwp) WRITE(numout,*) TRIM(clinfo)//' define dimension variables done'
+      ENDIF
+
+      ! define the data if it is not already done
+      ! ===============
+      idvar = iom_varid( knumfl, cdvar )
+      IF( idvar <= 0 ) THEN
+         ! variable definition
+         IF(     PRESENT(pv_r0d) ) THEN   ;   idims = 0
+         ELSEIF( PRESENT(pv_r1d) ) THEN   ;   idims = 2   ;   idimid(1:idims) = (/    3,4/)
+         ELSEIF( PRESENT(pv_r2d) ) THEN   ;   idims = 3   ;   idimid(1:idims) = (/1,2  ,4/)
+         ELSEIF( PRESENT(pv_r3d) ) THEN   ;   idims = 4   ;   idimid(1:idims) = (/1,2,3,4/)
+         ENDIF
+         IF( PRESENT(pv_r0d) ) THEN   ;   CALL fliodefv (knumfl, cdvar                 , v_t = flio_r8)
+         ELSE                         ;   CALL fliodefv (knumfl, cdvar, idimid(1:idims), v_t = flio_r8)
+         ENDIF
+         ! update informations structure related the new variable we want to add...
+         idvar                          = iom_file(knumfl)%nvars + 1
+         iom_file(knumfl)%nvars         = idvar
+         iom_file(knumfl)%cn_var(idvar) = TRIM(cdvar)
+         iom_file(knumfl)%scf(idvar)    = 1.
+         iom_file(knumfl)%ofs(idvar)    = 0.
+         iom_file(knumfl)%ndims(idvar)  = idims
+         IF( .NOT. PRESENT(pv_r0d) ) THEN
+            iom_file(knumfl)%luld(idvar) = .TRUE.
+            CALL flioinqf( knumfl, ln_dim = idimsz )
+            iom_file(knumfl)%dimsz(1:idims-1,idvar) = idimsz(idimid(1:idims-1))
+         ENDIF
+         IF(lwp) WRITE(numout,*) TRIM(clinfo)//' defined ok'
+      ENDIF
+
+      ! time step kwrite : write the variable
+      IF( kt == kwrite ) THEN
+         ! on what kind of domain must the data be written?
+         IF( PRESENT(pv_r2d) .OR. PRESENT(pv_r3d) ) THEN
+            idimsz(1:2) = iom_file(knumfl)%dimsz(1:2,idvar)
+            IF(     idimsz(1) == (nlei - nldi + 1) .AND. idimsz(2) == (nlej - nldj + 1) ) THEN
+               ix1 = nldi   ;   ix2 = nlei   ;   iy1 = nldj   ;   iy2 = nlej
+            ELSEIF( idimsz(1) == nlci              .AND. idimsz(2) == nlcj              ) THEN
+               ix1 = 1      ;   ix2 = nlci   ;   iy1 = 1      ;   iy2 = nlcj
+            ELSEIF( idimsz(1) == jpi               .AND. idimsz(2) == jpj               ) THEN
+               ix1 = 1      ;   ix2 = jpi    ;   iy1 = 1      ;   iy2 = jpj
+            ELSE 
+               CALL ctl_stop( 'iom_rstput_0123d: should have been an impossible case...' )
+            ENDIF
+
+            ! write dimension variables if it is not already done
+            ! =============
+            IF( iom_file(knumfl)%dimsz(1, 1) == 0 ) THEN
+               CALL flioputv( knumfl, 'nav_lon'     , glamt(ix1:ix2, iy1:iy2) )
+               CALL flioputv( knumfl, 'nav_lat'     , gphit(ix1:ix2, iy1:iy2) )
+               CALL flioputv( knumfl, 'nav_lev'     , gdept_0 )
+               CALL flioputv( knumfl, 'time_counter', kt )   ! +++ WRONG VALUE: to be improved but not really useful...
+               ! update informations structure related the dimension variable
+               iom_file(knumfl)%dimsz(1:2, 1) = idimsz(1:2)
+               iom_file(knumfl)%dimsz(1:2, 2) = idimsz(1:2)
+               iom_file(knumfl)%dimsz(1, 3:4) = (/idimsz(3), 1/)
+               IF(lwp) WRITE(numout,*) TRIM(clinfo)//' write dimension variables done'
+            ENDIF
+         ENDIF
+
+         ! write the data
+         ! =============
+         IF(     PRESENT(pv_r0d) ) THEN   ;   CALL flioputv( knumfl, cdvar, pv_r0d                      )
+         ELSEIF( PRESENT(pv_r1d) ) THEN   ;   CALL flioputv( knumfl, cdvar, pv_r1d(                  :) )
+         ELSEIF( PRESENT(pv_r2d) ) THEN   ;   CALL flioputv( knumfl, cdvar, pv_r2d(ix1:ix2, iy1:iy2   ) )
+         ELSEIF( PRESENT(pv_r3d) ) THEN   ;   CALL flioputv( knumfl, cdvar, pv_r3d(ix1:ix2, iy1:iy2, :) )
+         ENDIF
+         ! add 1 to the size of the temporal dimension (not really useful...)
+         IF( iom_file(knumfl)%luld(idvar) )   iom_file(knumfl)%dimsz(iom_file(knumfl)%ndims(idvar), idvar)    &
+            &                               = iom_file(knumfl)%dimsz(iom_file(knumfl)%ndims(idvar), idvar) + 1
+         IF(lwp) WRITE(numout,*) TRIM(clinfo)//' written ok'
+      ENDIF
+      !     
+   END SUBROUTINE iom_rstput_0123d
+   
    !!======================================================================
 END MODULE iom
